﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.IO.Ports;
using System.ServiceProcess;


namespace gm_p1
{
    public partial class Form1 : Form
    {
        public const int PT_NUM = 300;

        static int[] ain = new int[8];
        static Point[] ptx, pty, ptz, ptd;
        static int pt_cnt;
        Bitmap graph_base = new Bitmap(700, 350);
        static bool disp_x = false; // x
        static bool disp_y = false; // y
        static bool disp_z = false; // z
        static bool disp_d = false; // 距離

        public Form1()
        {
            InitializeComponent();
            pt_cnt = 0;
            ptx = new Point[700];
            ptx[0].X = 0;
            ptx[0].Y = 0;
            pty = new Point[700];
            pty[0].X = 0;
            pty[0].Y = 0;
            ptz = new Point[700];
            ptz[0].X = 0;
            ptz[0].Y = 0;
            ptd = new Point[700];
            ptd[0].X = 0;
            ptd[0].Y = 0;
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            draw_base_graph();
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
        }

        private void draw_base_graph()
        {
            int i;
            Pen pb = new Pen(Color.Black, 3);
            Pen pp = new Pen(Color.Pink, 1);

            Graphics g = Graphics.FromImage(graph_base);

            g.FillRectangle(Brushes.White, 0, 0, pictureBox1.Width, pictureBox1.Height);

            pp.DashStyle = DashStyle.Dot;

            for (i = 0; i < pictureBox1.Height; i = i + 50)
            {
                g.DrawLine(pp, 0, i, pictureBox1.Width, i);

            }
            for (i = 0; i < pictureBox1.Width; i = i + 50)
            {
                g.DrawLine(pp, i, 0, i, pictureBox1.Height);
            }
            g.DrawLine(pb, 50, 0, 50, pictureBox1.Height);
            g.DrawLine(pb, 0, pictureBox1.Height - 50, pictureBox1.Width, pictureBox1.Height - 50);
            pictureBox1.Image = graph_base;
            g.Dispose();

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int height = pictureBox1.Height - 50;
            
            Pen pr = new Pen(Color.Red, 1);
            Pen pg = new Pen(Color.Green, 1);
            Pen pb = new Pen(Color.Blue, 1);
            Pen pp = new Pen(Color.Magenta, 1);

            Graphics g = Graphics.FromImage(graph_base);

            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("I*");

                if (pt_cnt > pictureBox1.Width - 50)
                {
                    pt_cnt = 1;
                    draw_base_graph();
                }
                else
                {
                    pt_cnt++;
                }

                ptx[pt_cnt].X = pt_cnt;
                ptx[pt_cnt].Y = ain[1];
                label1.Text = ain[1].ToString();

                pty[pt_cnt].X = pt_cnt;
                pty[pt_cnt].Y = ain[2];
                ptz[pt_cnt].X = pt_cnt;
                ptz[pt_cnt].Y = ain[3];

                ptd[pt_cnt].X = pt_cnt;
                ptd[pt_cnt].Y = ain[0];

                if (disp_x) g.DrawLine(pr, ptx[pt_cnt - 1].X + 50, height - ptx[pt_cnt - 1].Y, pt_cnt + 50, height - ain[1]);
                if (disp_y) g.DrawLine(pg, pty[pt_cnt - 1].X + 50, height - pty[pt_cnt - 1].Y, pt_cnt + 50, height - ain[2]);
                if (disp_z) g.DrawLine(pb, ptz[pt_cnt - 1].X + 50, height - ptz[pt_cnt - 1].Y, pt_cnt + 50, height - ain[3]);
                if (disp_d) g.DrawLine(pp, ptd[pt_cnt - 1].X + 50, 95+ptd[pt_cnt - 1].Y, pt_cnt + 50, 95+ain[0]);

                pictureBox1.Image = graph_base;
                g.Dispose();
            }

           // Invalidate();
        }

        private void Btn_timer_start_Click(object sender, EventArgs e)
        {
            int i;
            if (serialPort1.IsOpen == true)
            {
                //アナログデータ初期化
                for (i = 0; i < 8; i++)
                {
                    ain[i] = 0;
                }
//                serialPort1.Write("i*");
                timer1.Start();
                
            }
            else
            {
                MessageBox.Show("GAINER miniと\n接続してください");
            }
        }

        private void Btn_timer_stop_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("Q*");
                serialPort1.Write("KONFIGURATION_4*");
            }
            else serialPort1.Close();

        }

        private void Btn_image_clear_Click(object sender, EventArgs e)
        {

            Graphics g = Graphics.FromImage(graph_base);

            g.FillRectangle(Brushes.White, 0,0, pictureBox1.Width, pictureBox1.Height);
            g.Dispose();

            //カウントを原点に戻す
            pt_cnt = 1;
            draw_base_graph();
        }

        private void comportBox1_DropDown(object sender, EventArgs e)
        {
            // すべてのシリアル・ポート名を取得する
            string[] ports = SerialPort.GetPortNames();

            // シリアルポートを毎回取得して表示するために表示の度にリストをクリアする
            Combo_comport.Items.Clear();

            foreach (string port in ports)
            {
                // 取得したシリアル・ポート名を出力する
                Combo_comport.Items.Add(port);
            }
        }
        private void Combo_comport_SelectedIndexChanged(object sender, EventArgs e)
        {
            //接続していたらシリアルポートをまず閉じる
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Close();                //COMポートを閉じる
            }

            if (Combo_comport.Text != "")
            {
                serialPort1.PortName = Combo_comport.Text;
                //*** エラー処理 ***
                try
                {
                    serialPort1.Open();                 //ポートオープン
                    if (serialPort1.IsOpen == true)
                    {
                        serialPort1.Write("KONFIGURATION_4*");
                    }
                    else
                    {
                        MessageBox.Show("通信失敗");
                    }
                }
                catch //(Exception ex)
                {
                    MessageBox.Show("接続失敗\n"+Combo_comport.Text + "が接続されていません");
                }
                if (serialPort1.IsOpen == true) {
                MessageBox.Show(Combo_comport.Text + "に接続しました。");
                label1.Text = Combo_comport.Text + "接続中";
                }
            }
            else MessageBox.Show("COMポートを設定してください");
        }

        void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            int i;
            String myText = "";

            byte[] readData = new byte[serialPort1.BytesToRead];
            serialPort1.Read(readData, 0, readData.Length);
            for (i = 0; i < readData.Length; i++)
            {
                myText += (char)((int)readData[i]);
            }

            //MessageBox.Show(myText);
            Invoke(new AppendTextDelegate(myAppendText), myText);

            if (readData[0] == 'I')
            {
                show_config4(myText);
            }

        }
        // process間で異なるフォームファクターにアクセスするための宣言
        delegate void AppendTextDelegate(String text);
        private void myAppendText(String text)
        {
            richTextBox1.Text =text;
            label2.Text = text.Length.ToString();
        }


        int get_data(char data1, char data2)
        {
            int data = 0;

            if (data1 >= 'A')
            {
                data = (10 + (data1 - 'A')) * 16;
            }
            else
            {
                data = (data1 - '0') * 16;
            }
            if (data2 >= 'A')
            {
                data += (10 + (data2 - 'A'));
            }
            else
            {
                data += data1 - '0';
            }
            // MessageBox.Show(data1.ToString() + data2.ToString());
            return data;
        }


        String get_strings16(char data1, char data2)
        {
            String data_string = "";

            data_string += data1;
            data_string += data2;

            return data_string;
        }

        // 10進数での文字列を得る
        String get_strings(char data1, char data2)
        {
            int data;


            if (data1 >= 'A')
            {
                data = (10 + (data1 - 'A')) * 16;
            }
            else
            {
                data = (data1 - '0') * 16;
            }
            if (data2 >= 'A')
            {
                data += (10 + (data2 - 'A'));
            }
            else
            {
                data += data1 - '0';
            }

            return data.ToString();
        }

        void show_config4(string readData)
        {
            int i;

            if (readData[0] != 'I' ) return;

            for(i=0;i<8;i++)
            {
               ain[i] = get_data(readData[i*2+1], readData[i*2+2]);
            }
        }


        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            //ウィンドウが閉じるときにシリアルポートを閉じておく
            if (serialPort1.IsOpen == true)
            {
                if (serialPort1.IsOpen == true)
                {
                    serialPort1.Write("Q*");

                }
                else serialPort1.Close();
                //System.Threading.Thread.Sleep(1000);

                
                serialPort1.Close();
                MessageBox.Show("シリアルポートを閉じました！");
            }

            if (timer1.Enabled == true)
            {
                timer1.Stop();
            }
            graph_base.Dispose();
        }

        private void checkBoxZ_CheckedChanged(object sender, EventArgs e)
        {
            disp_z = (! disp_z);
        }

        private void checkBoxY_CheckedChanged(object sender, EventArgs e)
        {
            disp_y = (!disp_y);
        }

        private void checkBoxX_CheckedChanged(object sender, EventArgs e)
        {
            disp_x = (!disp_x);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            disp_d = (!disp_d);
        }
        
    }
}
